<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelInventorySpecialNotesNote ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelInventorySpecialNotesNote extends AbstractStructArrayBase
{
    /**
     * The Note
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Note[]
     */
    public $Note;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     * @uses ArrayOfJPSOAP_HotelInventorySpecialNotesNote::setNote()
     * @param \StructType\Note[] $note
     */
    public function __construct(array $note = array())
    {
        $this
            ->setNote($note);
    }
    /**
     * Get Note value
     * @return \StructType\Note[]|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * This method is responsible for validating the values passed to the setNote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNoteForArrayConstraintsFromSetNote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem instanceof \StructType\Note) {
                $invalidValues[] = is_object($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) ? get_class($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem), var_export($arrayOfJPSOAP_HotelInventorySpecialNotesNoteNoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Note property can only contain items of type \StructType\Note, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Note value
     * @throws \InvalidArgumentException
     * @param \StructType\Note[] $note
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     */
    public function setNote(array $note = array())
    {
        // validation for constraint: array
        if ('' !== ($noteArrayErrorMessage = self::validateNoteForArrayConstraintsFromSetNote($note))) {
            throw new \InvalidArgumentException($noteArrayErrorMessage, __LINE__);
        }
        $this->Note = $note;
        return $this;
    }
    /**
     * Add item to Note value
     * @throws \InvalidArgumentException
     * @param \StructType\Note $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventorySpecialNotesNote
     */
    public function addToNote(\StructType\Note $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Note) {
            throw new \InvalidArgumentException(sprintf('The Note property can only contain items of type \StructType\Note, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Note[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Note|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Note|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Note|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Note|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Note|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Note
     */
    public function getAttributeName()
    {
        return 'Note';
    }
}
